
.include "8515def.inc"

.equ pwu = 100
.equ timerwert = -100
.equ dwn = 0
.equ rpt = 1

.def soll0 = r0                ; Sollwert Kanal 1
.def soll1 = r1                ; Sollwert Kanal 2
.def soll2 = r2                ; Sollwert Kanal 3
.def soll3 = r3                ; Sollwert Kanal 4
.def soll4 = r4                ; Sollwert Kanal 5
.def soll5 = r5                ; Sollwert Kanal 6
.def soll6 = r6                ; Sollwert Kanal 7
.def soll7 = r7                ; Sollwert Kanal 8
.def tsw = r8

.def last = r22
.def temp = r16
.def sregtemp = r17
.def pwz = r18
.def flg = r19
.def mode = r20
.def tastens = r21

.org 0x000

rjmp Reset
reti
reti
reti
reti
reti
reti
rjmp Time0_OVF

Reset:

clr soll0
clr soll1
clr soll2
clr soll3
clr soll4
clr soll5
clr soll6
clr soll7

ldi temp, high(ramend)
out sph, temp
ldi temp, low (ramend)
out spl, temp                     ; Stack initialisiert

ldi temp, 0xff
out ddrb, temp                    ; Ports B = Ausgang
out portb,temp                    ; LED aus

ldi temp, 0x00
out ddrd, temp                    ; Ports d = Eingang

ldi temp, 0x01
out tccr0, temp                   ; Timertakt = 1:1
ldi temp, 0x02
out timsk, temp                   ; Timer OVF freigeben
ldi temp, 50
mov soll0, temp
sei 

Haupt:

rcall Tasten
                   ; Hauptprogramm Endlosschleife

Time0_OVF:

in sregtemp, sreg                   ; Sreg sichern

inc pwz                             ; zu pwz 1 addieren
cpi pwz, pwu                        ; vergleiche pwz u. pwu
brne Time0_a                        ; wenn ungleich sprung
clr pwz                             ; pwz lschen

Time0_a:

cp pwz, soll0                       ; Sollwert  erreicht
rol temp                            ; Carry-Bit sichern
cp pwz, soll1
rol temp
cp pwz, soll2
rol temp
cp pwz, soll3
rol temp
cp pwz, soll4
rol temp
cp pwz, soll5
rol temp
cp pwz, soll6
rol temp
cp pwz, soll7
rol temp
com temp                           ; invertieren da low-aktive LED
out portB, temp                    ; Ausgabe 

out sreg, sregtemp                  ; Sreg wiederherstellen
reti

Tasten:

in tastens, pind     ; in r16 pinD
sbrs flg,dwn     ; wenn r19 Bit0 = 1, n. Befehl bersringen (taste war gedrckt)
rjmp T1
cpse last,tastens    ; wenn r22 gleich r16, n. Befehl bersringen
rjmp T1
sbrc flg,rpt     ; wenn r19 Bit1 = 0 , n. Befehl bersringen (taste wiederholt gedrckt)
rjmp Haupt
mov mode, tastens    ; r25 nach r20 kopieren
sbr flg,1<<rpt   ; r19 Bit1 setzen,
rjmp Ausgabe

T1:

cpi r21, 0xFF    ; Vergleiche r21 und 0xff
breq T3         ; wenn gleich sprung = keine Taste gedrckt

mov last, tastens    ;
cbr flg,1<<rpt  ;
sbr flg,1<<dwn   ;
rjmp Haupt

T3:

cbr flg,1<<dwn
cbr flg,1<<rpt
rjmp Haupt

Ausgabe:

sbrs mode, 0
rjmp mode0
sbrs mode, 1
rjmp mode1

mode0:

ldi temp, 50
add Soll0, temp
rjmp Haupt

mode1:

ldi temp, 50
sub Soll0, temp
rjmp Haupt
